<!doctype html>
<html>
<head>
  <title>Kawal Covid 2019 - Network</title>
  <script type="text/javascript" src="https://unpkg.com/vis-network/standalone/umd/vis-network.min.js"></script>
  <style type="text/css">
    #mynetwork {
      width: 1024px;
      height: 1024px;
      border: 1px solid lightgray;
    }
  </style>
</head>
<body>
<div id="mynetwork"></div>
<script type="text/javascript">
  var apiHost = "https://kawalcovid19-pasien.herokuapp.com/"
  var request = new XMLHttpRequest();

  var patients;
  request.open("GET", apiHost + "patients", false);
  request.send();
  if (request.status === 200) {
    patients = JSON.parse(request.responseText);
  }

  var clusters;
  request.open("GET", apiHost + "clusters", false);
  request.send();
  if (request.status === 200) {
    clusters = JSON.parse(request.responseText);
  }

  var nodes = [];
  var edges = [];
  patients.forEach((patient) => {
    nodes.push({id: patient.name, label: patient.name});

    patient.to_patients.forEach((infected) => {
      edges.push({from: patient.name, to: infected.name});
    });

    patient.to_clusters.forEach((infected) => {
      edges.push({from: patient.name, to: infected.name});
    });
  })

  clusters.forEach((cluster) => {
    var node = {id: cluster.name, label: cluster.name, shape: "dot"};
    if (cluster.image !== null) {
      node.shape = "circularImage";
      node.image = apiHost + cluster.image.url;
    }
    if (cluster.name === "Unknown Cluster") {
      node.hidden = true;
    }
    nodes.push(node);

    cluster.to_patients.forEach((infected) => {
      edges.push({from: cluster.name, to: infected.name});
    });

    cluster.to_clusters.forEach((infected) => {
      edges.push({from: cluster.name, to: infected.name});
    });
  })

  nodes = new vis.DataSet(nodes);
  edges = new vis.DataSet(edges);

  const nodesView = new vis.DataView(nodes)
  const edgesView = new vis.DataView(edges)

  // create a network
  var container = document.getElementById('mynetwork');
  var data = {
    nodes: nodesView,
    edges: edgesView
  };
  var options = {
    edges: {
      arrows: {
        to: {
          enabled: true,
          type: "arrow",
          scaleFactor: 1.0
        }
      }
    },
    physics: {
      solver: 'forceAtlas2Based',
      timestep: 0.35,
      stabilization: {
        enabled: true,
        iterations: 1000,
        updateInterval: 25
      }
    }
  };

  var network = new vis.Network(container, data, options);
</script>
</body>
</html>
